datablock PlayerData(SurvivorData : PlayerStandardArmor) {
	uiName = "Survivor Player";
	canJet = 0;
	maxTools = 3;

	firstPersonOnly = 1;
	thirdPersonOnly = 0;

	mass = 150;
	runForce = 4800;
	airControl = 0.025;

	jumpForce = 1332;
	jumpDelay = 15;

	minLookAngle = -1.4;
	maxLookAngle = 1.4;

	maxForwardSpeed = 9;
	maxBackwardSpeed = 6;
	maxSideSpeed = 7;

	maxForwardCrouchSpeed = 4;
	maxBackwardCrouchSpeed = 3;
	maxSideCrouchSpeed = 3;

	runSurfaceAngle = 55;
	jumpSurfaceAngle = 55;

	isZombie = 0;
	isSurvivor = 1;
};

function SurvivorData::onAdd(%this, %obj) {
	parent::onAdd(%this, %obj);
}

function SurvivorData::damage(%this, %obj, %src, %origin, %damage, %type) {
	%miniGame = getMiniGameFromObject(%obj);

	if (!isObject(%miniGame) || !isObject(%miniGame.zamb)) {
		return parent::damage(%this, %obj, %src, %origin, %damage, %type);
	}

	if (!isObject(%src) || %src == %obj) {
		return parent::damage(%this, %obj, %src, %origin, %damage, %type);
	}

	if (!(%src.getType() & $TypeMasks::PlayerObjectType) || !%src.getDataBlock().isSurvivor) {
		return parent::damage(%this, %obj, %src, %origin, %damage, %type);
	}

	%mod = 1;

	switch (%miniGame.zamb.difficulty) {
		case 0: %mod = 0;
		case 1: %mod = 0.1;
		case 2: %mod = 0.5;
	}

	parent::damage(%this, %obj, %src, %origin, %damage * %mod, %type);
}
