datablock playerData(TankZombieData : ZombieData) {
	zombieType = 3;
	noZombiePush = 1;
	hasFootsteps = 0; // 1

	mass = 300;
	maxDamage = 3000;

	runForce = 3000;
	jumpForce = 2000;

	maxForwardSpeed = 5;
	maxBackwardSpeed = 4;
	maxSideSpeed = 2;

	footstepMaterial = "tank_walk";

	alternateFootstepMaterial["slosh"] = "tank_water";
	alternateFootstepMaterial["wade"] = "tank_water";
};

function TankZombieData::onAdd(%this, %obj) {
	ZombieData::onAdd(%this, %obj);
	// %obj.music = zambEmitLoop(zamb_music_tank, 1, 1);
}

function TankZombieData::onRemove(%this, %obj) {
	if (isObject(%obj.music)) {
		%obj.music.delete();
	}

	ZombieData::onRemove(%this, %obj);
}

function TankZombieData::onReachDestination(%this, %obj) {
	ZombieData::onReachDestination(%this, %obj);
}

function TankZombieData::applyZombieAppearance(%this, %obj) {
	ZombieData::applyZombieAppearance(%this, %obj);
	%obj.setScale("1.3 1.45 1.45");
}

function TankZombieData::zombieAttack(%this, %obj) {
	if ($Sim::Time < %obj.attackReadyTime) {
		return;
	}

	if (!isObject(%obj.getControllingClient())) {
		%start = %obj.getHackPosition();
		%eye = %obj.getEyeVector();

		initContainerRadiusSearch(%start, 6, $TypeMasks::PlayerObjectType);

		while (isObject(%col = containerSearchNext())) {
			if (%col.getDataBlock().isZombie || %col.getState() $= "Dead") {
				continue;
			}

			%end = %col.getHackPosition();

			if (vectorDist(%start, %end) >= 6) {
				continue;
			}

			%line = vectorNormalize(vectorSub(%col.position, %obj.position));

			if (vectorDot(%eye, %line) >= 0.5) {
				%ray = containerRayCast(%start, %end, $TypeMasks::FxBrickObjectType);

				if (%ray $= "0") {
					%hit = true;
					break;
				}
			}
		}
	}

	if (isObject(%obj.getControllingClient()) || %hit) {
		%obj.attackReadyTime = $Sim::Time + 2;
		%obj.playThread(0, "activate2");

		%this.schedule(500, "doZombieAttack", %obj);
	}
}

function TankZombieData::doZombieAttack(%this, %obj) {
	if (!isObject(%obj) || %obj.getState() $= "Dead") {
		return;
	}

	%start = %obj.getHackPosition();
	%eye = %obj.getEyeVector();

	initContainerRadiusSearch(%start, 6, $TypeMasks::PlayerObjectType);

	while (isObject(%col = containerSearchNext())) {
		if (%col.getState() $= "Dead") {
			continue;
		}

		%end = %col.getHackPosition();

		if (vectorDist(%start, %end) >= 6) {
			continue;
		}

		%line = vectorNormalize(vectorSub(%col.position, %obj.position));

		if (vectorDot(%eye, %line) >= 0.5) {
			%ray = containerRayCast(%start, %end, $TypeMasks::FxBrickObjectType);

			if (%ray $= "0") {
				%hit = true;

				%col.setVelocity(vectorAdd(vectorScale(%line, 20), "0 0 12"));
				%col.damage(%obj, %end, 40, $DamageType::Suicide);
			}
		}
	}
}

function TankZombieData::updateAI(%this, %obj) {
	ZombieData::updateAI(%this, %obj);
}

function TankZombieData::updateTarget(%this, %obj) {
	ZombieData::updateTarget(%this, %obj);
}

function TankZombieData::getTargetScore(%this, %obj, %target) {
	return ZombieData::getTargetScore(%this, %obj, %target);
}

function TankZombieData::directMovement(%this, %obj) {
	return ZombieData::directMovement(%this, %obj);
}

function TankZombieData::pathedMovement(%this, %obj) {
	return ZombieData::pathedMovement(%this, %obj);
}

function TankZombieData::shouldStrafe(%this, %obj, %dist) {
	return ZombieData::shouldStrafe(%this, %obj, %dist);
}

function TankZombieData::shouldJump(%this, %obj, %dist) {
	return ZombieData::shouldJump(%this, %obj, %dist);
}

function TankZombieData::shouldCrouch(%this, %obj, %dist) {
	return ZombieData::shouldCrouch(%this, %obj, %dist);
}
